#!/usr/bin/python 
  # Script zur Darstellung eines Farbspektrums 
 
def ind2col(ind): 
     ind %= 6 * 256 
     i, j = divmod(ind, 256) 
     a = 0x10000 >> (8 * (i % 3)) 
     if i & 1: 
         b = j 
     else: 
         b = 255 -j 
     c = 0xFF << (8 * (i / 2)) 
     return a * b + c 
     
def callback(event):
	canvas = event.widget
	obj = canvas.find_closest(event.x, event.y)
	rgbwert = canvas.itemcget(obj, "fill")
	ser.write(rgbwert[1:])
	print rgbwert[1:]	
 
if __name__ == '__main__': 
     from Tkinter import *
     import serial
     ser = serial.Serial('/dev/ttyUSB0', 9600, timeout=1)
     root = Tk() 
     root.title('Farbspektrum') 
     height = 50 
     width = 6 * 256 / 2 
     canvas = Canvas(root, width=width, height=height, bg='white') 
     canvas.pack(expand=YES, fill=BOTH) 
     for i in range(width): 
         canvas.create_line(i, 0, i, height, fill='#%06X' % ind2col(2 * i)) 
     canvas.bind("<Button-1>", callback)
     root.mainloop() 
