#include <stdlib.h>
#include <avr/io.h>
// Peter Fleury's Uart Lib einbinden
#include "uart.h" 

/* define CPU frequency in Mhz here if not defined in Makefile */
#ifndef F_CPU
#define F_CPU 8000000L
#endif

#include <util/delay.h>
#include <avr/interrupt.h>

/* 9600 baud */
#define UART_BAUD_RATE      9600

// Funktion zum Lesen von Strings
void uart_gets( char* Buffer, uint8_t MaxLen )
{
	uint8_t NextChar;
  	uint8_t StringLen = 0;
 
  	NextChar = uart_getc();  

  	while( NextChar != '\n' && StringLen < MaxLen -1) {
    		 *Buffer++ = NextChar;
    		 StringLen++;
   		 NextChar = uart_getc();
  	}
 
  	*Buffer = '\0';
}

int main(void)
{
	
	char Line[7]; // Hier kommt der String rein
	// r,g und b für die Hexadezimal Werte als Char der einzelnen Farben
	char r[3]; 
	char g[3];
	char b[3];
	r[2]='\0';
	b[2]='\0';
	g[2]='\0';

	// Initialize
	uart_init( UART_BAUD_SELECT(UART_BAUD_RATE,F_CPU) );
	
	// Interrupts aktivieren mit sei() 
	sei();
	// Die drei Leds als Ausgänge definieren
	DDRB |= (1<<PB1);
	DDRB |= (1<<PB2);
	DDRB |= (1<<PB3);

	TCCR1A = 0x00;
	TCCR1A = (1<<WGM10)|(1<<COM1A1)|(1<<COM1B1);
	TCCR1B = (1<<CS10);

 	// Timer2 init for PWM on Pin PB3 
	TCCR2 = 0x00;            //stop T/C2 
	TCCR2 = (1<<WGM20) |(1<< CS20)|(1<<COM21); 

	// Am Anfang sollen die Leds aus sein
	OCR1A = 0;
	OCR1B = 0;
	OCR2 = 0;

	for(;;)
	{	
		// Eine Zeile einlesen
		uart_gets(Line, sizeof(Line));
		
		_delay_ms(1000);
		_delay_ms(1000);
		_delay_ms(1000);
		_delay_ms(1000);
		_delay_ms(1000);


		// Den Farbcode auf die drei Farben aufteilen
		// Vorher abfragen ob es sich um hexadezimal Ziffern handelt
		if( (Line[0] == '0') | (Line[0] == '1') | (Line[0] == '2') | (Line[0] == '3') | (Line[0] == '4') | (Line[0] == '5') | (Line[0] == '6') | (Line[0] == '7') | (Line[0] == '8') | (Line[0] == '9') | (Line[0] == 'A') | (Line[0] == 'B') | (Line[0] == 'C') | (Line[0] == 'D') | (Line[0] == 'E') | (Line[0] == 'F'))
		{
			r[0]=Line[0];
			r[1]=Line[1];
			g[0]=Line[2];
			g[1]=Line[3];
			b[0]=Line[4];
			b[1]=Line[5];
		}
		// Die Hexadezimal Werte welche als char vorhanden sind umwandeln und zuweisen
		OCR1A = strtol(g,NULL,16);	
		OCR1B = strtol(b,NULL,16);
		OCR2 = strtol(r,NULL,16);
		
	}
}
